#include<stdio.h>
#include<unistd.h>
#include<stdlib.h>

#define SPACE 0x1000
#define NOTE_INFO(n) (&(((struct note*) n)->info))

size_t free_space = SPACE;

struct note_info
{
	int len, used;
};

struct note
{
	struct note_info info;
	char content[1];
};

struct note* head;

void win()
{
	system("/bin/get_flag");
}

struct note* tail()
{
	char* ptr = (char*) head;
	int len;
	while ((len = NOTE_INFO(ptr)->len))
		ptr += sizeof(struct note_info) + len;
	return (struct note*) ptr;
}

struct note* get_note(int num)
{
	char* ptr = (char*) head;
	int len;
	while (num > 0 || !NOTE_INFO(ptr)->used)
	{
	       	num -= NOTE_INFO(ptr)->used;
	       	if (!(len = NOTE_INFO(ptr)->len))
			exit(1);
		ptr += sizeof(struct note_info) + len;
	}
	return (struct note*) ptr;
}

int get_int()
{
	char buf[0x10] = { 0 };
	if (!read(0, buf, sizeof(buf)))
		exit(1);
	return atoi(buf);
}

void add_note()
{
	int len;
	struct note* new = tail();
	printf("content please > ");

	if (!(len = read(0, new->content, free_space - sizeof(struct note_info))))
		exit(1);

	new->info.len = len;
	new->info.used = 1;

	free_space -= len + sizeof(struct note_info);
}

void read_note()
{
	int num;
	puts("which note?");
	printf("> ");

	num = get_int();

	struct note* note = get_note(num);
	printf("%s\n", note->content);
}

void edit_note()
{
	int num;
	puts("which note?");
	printf("> ");

	num = get_int();

	struct note* note = get_note(num);

	printf("content please > ");

	if (!read(0, note->content, note->info.len))
		exit(1);

	if (note->content[note->info.len] == '\n')
		note->content[note->info.len] = '\0';
}

void del_note()
{
	int num;
	puts("which note?");
	printf("> ");

	num = get_int();

	struct note* note = get_note(num);
	note->info.used = 0;
}

void print_menu()
{
	puts("What do you want to do?");
	puts("1: Add note");
	puts("2: Read note");
	puts("3: Edit note");
	puts("4: Delete note");
	printf("> ");
}

int main ()
{
	setbuf(stdin, NULL);
	setbuf(stdout, NULL);

	char note_space[SPACE] = { 0 };
	head = (struct note*) note_space;

	puts("Welcome to Secure Notes as a Service");

	int choice;
	int running = 1;

	while (running)
	{
		print_menu();
		choice = get_int();
		switch(choice)
		{
		case 1:
			add_note();
			break;
		case 2:
			read_note();
			break;
		case 3:
			edit_note();
			break;
		case 4:
			del_note();
			break;
		default:
			running = 0;
		}
	}
}
